/// <reference types="react" />
import { CalendarViewType, WeekDayType } from './models';
export interface UseCalendarOptions {
    defaultDate?: Date | number | string;
    defaultWeekStart?: WeekDayType;
    defaultViewType?: CalendarViewType;
}
export default function useCalendar(options?: UseCalendarOptions): {
    calendar: {
        viewType: CalendarViewType;
        cursorDate: Date;
        year: number;
        month: number;
        day: number;
        weekStartsOn: WeekDayType;
        startWeekdayInMonth: number;
        weeksInMonth: number;
        weekendDays: {
            value: Date;
        }[];
        getDateCellByIndex: (weekIndex: number, dayIndex: number) => import("./models").DateCell;
        getCurrentWeekIndex: () => number;
        getWeekRow: (weekIndex?: number) => import("./models").WeekRow;
        getMonth: (weeks?: number) => import("./models").MonthMatrix;
    };
    headers: {
        weekDays: ({
            value: Date;
        } & {
            key: string;
        })[];
    };
    body: {
        value: ({
            value: (import("./models").DateCell & {
                key: string;
            })[];
        } & {
            key: string;
        })[];
    };
    navigation: {
        toNext: () => void;
        toPrev: () => void;
        setToday: () => void;
        setDate: (date: Date) => void;
    };
    view: {
        type: CalendarViewType;
        setViewType: import("react").Dispatch<import("react").SetStateAction<CalendarViewType>>;
        setWeekStartsOn: import("react").Dispatch<import("react").SetStateAction<WeekDayType>>;
        isMonthView: boolean;
        isWeekView: boolean;
        isDayView: boolean;
        showMonthView: () => void;
        showWeekView: () => void;
        showDayView: () => void;
    };
};
