import { setHours, setMinutes, setSeconds, setMilliseconds, isEqual, isSameMonth as isSameMonth$1, isSameYear, setDay, startOfMonth, getDaysInMonth, addDays, addWeeks, addMonths, subDays, subWeeks, subMonths } from 'date-fns';
import { useMemo, useState, useCallback } from 'react';

var CalendarViewtype;

(function (CalendarViewtype) {
  CalendarViewtype["Month"] = "month";
  CalendarViewtype["Week"] = "week";
  CalendarViewtype["Day"] = "day";
})(CalendarViewtype || (CalendarViewtype = {}));

var CalendarViewType = CalendarViewtype;

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var defineProperty = _defineProperty;

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

var arrayWithHoles = _arrayWithHoles;

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

var iterableToArrayLimit = _iterableToArrayLimit;

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

var arrayLikeToArray = _arrayLikeToArray;

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return arrayLikeToArray(o, minLen);
}

var unsupportedIterableToArray = _unsupportedIterableToArray;

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var nonIterableRest = _nonIterableRest;

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || unsupportedIterableToArray(arr, i) || nonIterableRest();
}

var slicedToArray = _slicedToArray;

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return arrayLikeToArray(arr);
}

var arrayWithoutHoles = _arrayWithoutHoles;

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

var iterableToArray = _iterableToArray;

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var nonIterableSpread = _nonIterableSpread;

function _toConsumableArray(arr) {
  return arrayWithoutHoles(arr) || iterableToArray(arr) || unsupportedIterableToArray(arr) || nonIterableSpread();
}

var toConsumableArray = _toConsumableArray;

function arrayOf(count) {
  return toConsumableArray(new Array(count).keys());
}

var randomId = 0;
var map = new Map();
function generateID(prefix) {
  if (map.has(prefix)) {
    var id = map.get(prefix);
    var newId = id + 1;
    map.set(prefix, newId);
    randomId = newId;
  } else {
    var _id = 1;
    map.set(prefix, _id);
    randomId = _id;
  }

  return "".concat(prefix, "-").concat(randomId);
}

function resetTimeOfDate(date) {
  return setHours(setMinutes(setSeconds(setMilliseconds(date, 0), 0), 0), 0);
}

function isSameDate(baseDate, targetDate) {
  var base = resetTimeOfDate(baseDate);
  var target = resetTimeOfDate(targetDate);
  return isEqual(base, target);
}

function isSameMonth(baseDate, targetDate) {
  return isSameMonth$1(targetDate, baseDate) && isSameYear(targetDate, baseDate);
}

function parseDate(date) {
  return {
    year: date.getFullYear(),
    month: date.getMonth(),
    day: date.getDate()
  };
}

// Copied from https://github.com/gcanti/fp-ts/blob/1.15.0/src/function.ts#L209 with some
// modifications to make the first function allow multiple parameters.
function pipe() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return function () {
    for (var _len2 = arguments.length, initialParams = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      initialParams[_key2] = arguments[_key2];
    }

    return fns.reduce(function (value, fn, index) {
      var params = index === 0 ? value : [value];
      return fn.apply(void 0, toConsumableArray(params));
    }, initialParams);
  };
}
function pipeWith(value) {
  for (var _len3 = arguments.length, fns = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
    fns[_key3 - 1] = arguments[_key3];
  }

  return pipe.apply(void 0, fns)(value);
}

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function withKey(arr, keyPrefix) {
  return arr.map(function (value) {
    return _objectSpread(_objectSpread({}, value), {}, {
      key: generateID(keyPrefix)
    });
  });
}

function createCalendarInfo(cursorDate, weekStartsOn) {
  var _parseDate = parseDate(cursorDate),
      year = _parseDate.year,
      month = _parseDate.month,
      day = _parseDate.day;

  var startWeekdayInMonth = getStartWeekdayInMonth(cursorDate, weekStartsOn);
  var weeksInMonth = getWeeksInMonth(cursorDate, weekStartsOn);
  var weekendDays = arrayOf(7).map(function (index) {
    return {
      value: setDay(cursorDate, (index + weekStartsOn) % 7)
    };
  });

  var getCurrentWeekIndex = function getCurrentWeekIndex() {
    var control = (day - 1) % 7 > startWeekdayInMonth ? 0 : -1;
    return Math.ceil(day / 7) + control;
  };

  var getDateCellByIndex = function getDateCellByIndex(weekIndex, dayIndex) {
    var day = weekIndex * 7 + dayIndex - startWeekdayInMonth + 1;
    return {
      value: new Date(year, month, day)
    };
  };

  var getWeekRow = function getWeekRow() {
    var weekIndex = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getCurrentWeekIndex();
    return {
      value: arrayOf(7).map(function (dayIndex) {
        return getDateCellByIndex(weekIndex, dayIndex);
      })
    };
  };

  var getMonth = function getMonth() {
    var weeks = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : weeksInMonth;
    return {
      value: arrayOf(weeks).map(getWeekRow)
    };
  };

  return {
    cursorDate: cursorDate,
    year: year,
    month: month,
    day: day,
    weekStartsOn: weekStartsOn,
    startWeekdayInMonth: startWeekdayInMonth,
    weeksInMonth: weeksInMonth,
    weekendDays: weekendDays,
    getDateCellByIndex: getDateCellByIndex,
    getCurrentWeekIndex: getCurrentWeekIndex,
    getWeekRow: getWeekRow,
    getMonth: getMonth
  };
}

function getStartWeekdayInMonth(date, weekStartsOn) {
  var monthStartsAt = (startOfMonth(date).getDay() - weekStartsOn) % 7;
  return monthStartsAt < 0 ? monthStartsAt + 7 : monthStartsAt;
}

function getWeeksInMonth(date, weekStartsOn) {
  var _parseDate2 = parseDate(date),
      month = _parseDate2.month;

  var totalDaysOfMonth = getDaysInMonth(month);
  return Math.ceil((weekStartsOn + totalDaysOfMonth) / 7);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var objectWithoutPropertiesLoose = _objectWithoutPropertiesLoose;

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = objectWithoutPropertiesLoose(source, excluded);
  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

var objectWithoutProperties = _objectWithoutProperties;

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function withCurrentPropsMonth(baseDate, cursorDate) {
  return function (month) {
    return _objectSpread$1(_objectSpread$1({}, month), {}, {
      value: month.value.map(function (week) {
        return _objectSpread$1(_objectSpread$1({}, week), {}, {
          value: week.value.map(function (_ref) {
            var targetDate = _ref.value,
                restDayProps = objectWithoutProperties(_ref, ["value"]);

            var isCurrentMonth = isSameMonth(cursorDate, targetDate);
            var isCurrentDate = isSameDate(baseDate, targetDate);
            return _objectSpread$1(_objectSpread$1({}, restDayProps), {}, {
              value: targetDate,
              isCurrentMonth: isCurrentMonth,
              isCurrentDate: isCurrentDate
            });
          })
        });
      })
    });
  };
}

function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function withKeysMonth() {
  return function (month) {
    return _objectSpread$2(_objectSpread$2({}, month), {}, {
      value: withKey(month.value.map(function (week) {
        return _objectSpread$2(_objectSpread$2({}, week), {}, {
          value: withKey(week.value, 'days')
        });
      }), 'weeks')
    });
  };
}

function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function useCalendar() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var defaultDate = options.defaultDate,
      _options$defaultWeekS = options.defaultWeekStart,
      defaultWeekStart = _options$defaultWeekS === void 0 ? 0 : _options$defaultWeekS,
      _options$defaultViewT = options.defaultViewType,
      defaultViewType = _options$defaultViewT === void 0 ? CalendarViewType.Month : _options$defaultViewT;
  var baseDate = useMemo(function () {
    return defaultDate ? new Date(defaultDate) : new Date();
  }, [defaultDate]);

  var _useState = useState(defaultWeekStart),
      _useState2 = slicedToArray(_useState, 2),
      weekStartsOn = _useState2[0],
      setWeekStartsOn = _useState2[1];

  var _useState3 = useState(baseDate),
      _useState4 = slicedToArray(_useState3, 2),
      cursorDate = _useState4[0],
      setCursorDate = _useState4[1];

  var _useState5 = useState(defaultViewType),
      _useState6 = slicedToArray(_useState5, 2),
      viewType = _useState6[0],
      setViewType = _useState6[1];

  var calendar = createCalendarInfo(cursorDate, weekStartsOn);
  var weekendDays = calendar.weekendDays,
      getWeekRow = calendar.getWeekRow,
      getMonth = calendar.getMonth;
  var getHeaders = useCallback(function (viewType) {
    switch (viewType) {
      case CalendarViewType.Month:
      case CalendarViewType.Week:
        return {
          weekDays: withKey(weekendDays, 'weekdays')
        };

      case CalendarViewType.Day:
      default:
        return {
          weekDays: withKey([{
            value: cursorDate
          }], 'weekdays')
        };
    }
  }, [cursorDate, weekendDays]);
  var getBody = useCallback(function (viewType) {
    var monthTypeMonth = pipeWith(getMonth(), withCurrentPropsMonth(baseDate, cursorDate), withKeysMonth());
    var weekTypeMonth = pipeWith({
      value: [getWeekRow()]
    }, withCurrentPropsMonth(baseDate, cursorDate), withKeysMonth());
    var dayTypeWeeks = pipeWith({
      value: [{
        value: [{
          value: cursorDate
        }]
      }]
    }, withCurrentPropsMonth(baseDate, cursorDate), withKeysMonth());

    switch (viewType) {
      case CalendarViewType.Month:
        return monthTypeMonth;

      case CalendarViewType.Week:
        return weekTypeMonth;

      case CalendarViewType.Day:
      default:
        return dayTypeWeeks;
    }
  }, [baseDate, cursorDate, getMonth, getWeekRow]);
  var setNext = useMemo(function () {
    switch (viewType) {
      case CalendarViewType.Month:
        return addMonths;

      case CalendarViewType.Week:
        return addWeeks;

      case CalendarViewType.Day:
        return addDays;
    }
  }, [viewType]);
  var setPrev = useMemo(function () {
    switch (viewType) {
      case CalendarViewType.Month:
        return subMonths;

      case CalendarViewType.Week:
        return subWeeks;

      case CalendarViewType.Day:
        return subDays;
    }
  }, [viewType]);
  return {
    calendar: _objectSpread$3(_objectSpread$3({}, calendar), {}, {
      viewType: viewType
    }),
    headers: getHeaders(viewType),
    body: getBody(viewType),
    navigation: {
      toNext: function toNext() {
        return setCursorDate(function (date) {
          return setNext(date, 1);
        });
      },
      toPrev: function toPrev() {
        return setCursorDate(function (date) {
          return setPrev(date, 1);
        });
      },
      setToday: function setToday() {
        return setCursorDate(new Date());
      },
      setDate: function setDate(date) {
        return setCursorDate(date);
      }
    },
    view: {
      type: viewType,
      setViewType: setViewType,
      setWeekStartsOn: setWeekStartsOn,
      isMonthView: viewType === CalendarViewType.Month,
      isWeekView: viewType === CalendarViewType.Week,
      isDayView: viewType === CalendarViewType.Day,
      showMonthView: function showMonthView() {
        return setViewType(CalendarViewType.Month);
      },
      showWeekView: function showWeekView() {
        return setViewType(CalendarViewType.Week);
      },
      showDayView: function showDayView() {
        return setViewType(CalendarViewType.Day);
      }
    }
  };
}

export default useCalendar;
export { CalendarViewType };
//# sourceMappingURL=index.ts.map
